> For the complete documentation index, see [llms.txt](https://docs.2checkout.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.2checkout.com/soap-api-reference/soap-api-6.0/api-requests/upsell/place-orders-with-upsell-campaign.md).

# Place orders with upsell campaign

When calling the **placeOrder** method in order to place an order with an upsell campaign, the code of the master product and the campaign code need to be added to the `UpSell` object for the product item where it is applied.

## UpSell Object for the placeOrder API method

<table><thead><tr><th width="142.5333251953125">Parameter</th><th>Type / Description</th></tr></thead><tbody><tr><td><code>CampaignCode</code></td><td><strong>Required (string)</strong><br>The upsell campaign code.</td></tr><tr><td><code>ParentCode</code></td><td><strong>Required (string)</strong><br>Product code of the product to be recommended to the shopper.</td></tr><tr><td><code>PriceOptions</code></td><td><strong>Required (string)</strong><br>Array of <code>priceOptions</code> strings used on parent product.</td></tr><tr><td><code>Quantity</code></td><td><strong>Required (integer)</strong><br>Product quantity.</td></tr></tbody></table>

### Request sample

```json
{
  "Currency": "USD",
  "Language": "EN",
  "Country": "US",
  "CustomerIP": "10.10.10.10",
  "Source": "sourceAPI.net",
  "CustomerReference": 421820775,
  "Items": [
    {
      "Code": "15",
      "Quantity": 1
    },
    {
      "Code": "34924C876E",
      "Quantity": 1,
      "UpSell": {
        "CampaignCode": "1490b954-c299-430a-8134-e6a0501913ef",
        "ParentCode": "0BQ591VOTW",
        "PriceOptions": [
            "option_code_1"
        ],
        "Quantity": 5
      }
    }
  ],

  "BillingDetails":{
      "FirstName":"Customer First Name",
      "LastName":"Customer Last Name",
      "CountryCode":"US",
      "State":"California",
      "City":"San Francisco",
      "Address1":"Example Street",
      "Zip":"90210",
      "Email":"example@email.com"
  },

  "PaymentDetails": {
    "Type": "CC",
    "Currency": "USD",
    "CustomerIP": "10.10.10.10",
    "PaymentMethod": {
      "Vendor3DSReturnURL": "https://example.com",
      "Vendor3DSCancelURL": "https://example.com",
      "CardNumber": "4111111111111111",
      "CardType": "VISA",
      "ExpirationYear": "2020",
      "ExpirationMonth": "12",
      "CCID": "123"
    }
  }
}
```

## Response

Using the same structure, the **getContents** method will take into account the discount associated with the upsell campaign and display the appropriate prices and taxes.

```json
{
    "Country": "DE",
    "Currency": "EUR",
    "Items": [
        {
            "Code": "NIQRPI0GTU",
            "Quantity": 1
        },
        {
            "Code": "0XICS3OVDK",
            "Quantity": 1,
            "UpSell": {
                "CampaignCode": "1490b954-c299-430a-8134-e6a0501913ef",
                "ParentCode": "0BQ591VOTW",
                "PriceOptions": [
                    "option_code_1"
                ],
                "Quantity": 5
             }
        }
    ],

    "BillingDetails": {
        "FirstName": "Customer First Name",
        "LastName": "Customer Last Name",
        "CountryCode": "DE",
        "City": "Bucharest",
        "Address1": "Example Street",
        "Zip": "73331",
        "Email": "example@email.com"
    }
}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.2checkout.com/soap-api-reference/soap-api-6.0/api-requests/upsell/place-orders-with-upsell-campaign.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
